var TaskMgr = false;

var Statusgrid = {

	baseURL: "/opmon/seagull/www/index.php/statusgrid/action/",

	loadGrid: function(loadContext) {
		loadContext = loadContext || false;
		if (loadContext) {
			var context = Ext.get('gridContextPanel');
			if (context) {
				var contextURL = this.baseURL + context.dom.value + "/";
				if (parent.createContextSensitivePanel) {
					var contextLoaded = parent.Ext.get(context.dom.value);
					if (!contextLoaded)
						parent.createContextSensitivePanel( [contextURL] );
				}
			}
		}

		var loadShortcutPanel = Ext.get('gridShortcutPanel');
		if (loadShortcutPanel && parent.loadShortcut) {
			parent.loadShortcut(loadShortcutPanel.dom.value);
		}

		if (!TaskMgr)
			TaskMgr = new Ext.util.DelayedTask(this.loadGrid);

		TaskMgr.cancel();

		var icon = Ext.get('gridRefresh');
		if (icon)
			icon.dom.src = icon.dom.src.replace("refresh", "loading");

		var action = Ext.get('gridName').dom.value;
		var params = Ext.get('gridParams').dom.value;
		var filter = Ext.get('gridFilter').dom.value;

		var URL = Statusgrid.baseURL + action + "/?" + params;
		if (filter.length)
			URL += "&filter=" + filter;

		Ext.Ajax.request({
			url: URL,
			method: 'POST',
			callback: Statusgrid.processRequest
		});

	},
	openConfigurationWindow: function(data) {

		if (data.title === undefined) 
			data.title = langArray["Configurations"];

		if (data.width === undefined)
			data.width = 815;

		if (data.height === undefined)
			data.height = 540;

		WIZZARD_CONFIG_PARAMS = data;

		new Ext.Window({
			id: 'global_config_window',
			title : data.title,
			width : data.width,
			modal : true,
			height: data.height,
			layout : 'fit',
			items : [{
				xtype : "component",
				frame: false,
				border: false,
				autoEl : {
					tag : "iframe",
					src : "/opmon/seagull/modules/discovery/templates/wizardext/app.php"
				}
			}]
		}).show();
	},
	getSelectedHostNamesOnHostStatusGrid: function() {
		var rows;
		var row;
		var tds;
		var hostNames = [];
		var cols;

		cols = Ext.query(".host-selection-box");
		for(var i=0; i<cols.length; i++) {
			if (!cols[i].checked)
				continue;

			hostNames.push(cols[i].attributes.getNamedItem('hostname').value);
		}

		return hostNames;

	},
	getSelectedServiceDescriptionsOnServiceStatusGrid: function() {

		var services = [];
		var boxes = [];

		boxes = Ext.query(".service-selection-box");
		for(var i=0; i<boxes.length; i++) {
			if (!boxes[i].checked)
				continue;

			svc = {
				service_description: boxes[i].attributes.getNamedItem('servicedescription').value,
				host_name: boxes[i].attributes.getNamedItem('hostname').value
				
			};
			services.push(svc);
		}

		return services;
	},
	processRequest: function(opt,success,resp) {
		TaskMgr.delay(60000);

		if (!success)
			return;

		var filter = Ext.get('gridFilter').dom.value;
		try {
			obj = Ext.JSON.decode(filter);
			if (obj.statusgrid) {
				delete(obj.statusgrid);
				filter = Ext.JSON.encode(obj);

				// Empty object
				if (filter.length == 2) {
					filter = '';
				}

				delete(obj);
			}
		} catch(e) {
//			console.log(e.message);
		}

		try {
			var jsonString = resp.responseText;
			var obj = Ext.JSON.decode(jsonString);

			// Clean previous allocated memory
			Ext.each(MemoryMgr, function(memObj,memIndex) {
				if (memObj.destroy)
					memObj.destroy();
				else if (memObj.removeAllListeners)
					memObj.removeAllListeners();
			});

			MemoryMgr = [];

			Ext.get('gridHeader').dom.innerHTML = obj.header;
			Ext.get('gridHeaderBox').dom.style.display = 'block';
			Ext.get('gridTable').dom.innerHTML = obj.grid;
			Ext.get('gridToolbar').dom.innerHTML = obj.toolbar;
			if (obj.advancedSearch) {
				var adv = Ext.get('gridAdvancedSearch');
        			if (adv.dom.style.display === 'none')
					adv.dom.innerHTML = obj.advancedSearch;
			}

			StatusgridEvents.addCheckboxListeners();
			StatusgridEvents.renderComboboxes();
			StatusgridEvents.renderDatetimePicker();
			StatusgridEvents.renderDatePicker();

			if (obj.callback)
				eval("StatusgridCallback." + obj.callback + "();");

			var frm = parent.Ext.get('searchForm');
			if (filter.length && parent.frames.length && frm) {
				var oFilter = Ext.JSON.decode(filter);
				var input = frm.dom.elements[0];
				input.value = (oFilter.search) ? oFilter.search : "(" + langArray["Filter activated"] + ")";
				if (!input.className.match(" filter-active"))
					input.className += " filter-active";

				var btn = parent.Ext.get("cancelSearch");
				btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");
				btn.dom.style.cursor = "pointer";

			} else if (parent.frames.length && frm) {
				var input = frm.dom.elements[0];
				input.value = "";
				if (input.className.match(" filter-active"))
					input.className = "basic-search-input";

				var btn = parent.Ext.get("cancelSearch");
				btn.dom.style.cursor = "default";
			}
			
			delete(obj);
			delete(jsonString);
			
			if (doingPDF) {
				var icon = Ext.get('genpdf_icon');
				if (icon) {
					icon.dom.src = icon.dom.src.replace("icon-pdf", "loading");
				}
			}
		} catch(e) {
//			console.log(e.message);
		}
	},
	goToPage: function(page) {
		var el = Ext.get('gridParams');
		var str = el.dom.value.replace(/page=[\d]+\&/i,"page=" + page + "&");
		el.dom.value = str;
		this.loadGrid();
	},
	sortGrid: function(sortField) {

		var el = Ext.get('gridParams');

		var reg = /sortBy=(.*)&sortOrder=(.*)$/;
		var arr = reg.exec(el.dom.value);

		var curSortField = arr[1];
		var curSortOrder = arr[2];

		if (curSortField == sortField)
			curSortOrder = (curSortOrder == 'ASC') ? 'DESC' : 'ASC';
		else {
		   curSortField = sortField;
		   curSortOrder = 'ASC';
		}
		
		var str = el.dom.value;
		str = str.replace(arr[1],curSortField);
		str = str.replace(arr[2],curSortOrder);
		el.dom.value = str;

		this.goToPage(1);

	},
	changePageLimit: function(select) {

		var index = select.selectedIndex;
		var value = select.options[index].value;

		var el = Ext.get('gridParams');
		var str = el.dom.value.replace(/limit=[\d]+\&/i,"limit=" + value + "&");
		el.dom.value = str;

		this.goToPage(1);
	},
	inputGoToPage: function(element, e) {

		var code = false;
		if (e.keyCode)
			code = e.keyCode;
		else 
			e.which;
		
		if (code != 13)
			return;

		var page = parseInt(element.value);
		var maxPage = parseInt(Ext.get('gridMaxPage').dom.innerHTML);
		if (page < 1)
			page = element.value = 1;
		else if (page > maxPage)
			page = element.value = maxPage;

		this.goToPage(page);
	},
	rowMouseOver: function(el) {
		el.className += "-selected";
	},
	rowMouseOut: function(el) {
		el.className = el.className.replace("-selected","");
	},
	debug: function(msg) {
		Ext.get('DEBUG').dom.innerHTML += msg + "<br>";
	}
}
