var MemoryMgr = [];
var FilterMemoryMgr = [];

var StatusgridCallback = {

	// Host grid
	normalizeHostGrid: function() {

		// Add host tooltip
		var array = Ext.query('.host-tooltip');
		Ext.each( array, function(x,i) {

			var obj = Ext.get(array[i]);
			var ttip = new Ext.tip.ToolTip({
				target: obj.dom,
				trackMouse:true,
				mouseOffset: [0, 10],
				width: 400,
				showDelay: 1000,
				dismissDelay: 0,
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				loader: {
					url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_tooltip/?',
					method: 'POST',
					params: {
						host_name: obj.dom.innerHTML
					},
					text: langArray["Loading"] + '...',
					nocache: true
					//autoLoad: false
				},
				listeners: {
					beforeshow: function updateTipBody(tip) {
						tip.loader.load();
					}
				}
			});

			MemoryMgr.push(ttip);
		});

		// Add external links tooltip
		var array = Ext.query('.host-additional-links');
		Ext.each( array, function(x,i) {

			var obj = Ext.get(array[i]);
			var ttip = new Ext.tip.ToolTip({
				target: obj.dom,
				mouseOffset: [0, -5],
				width: 180,
				showDelay: 1000,
				dismissDelay: 0,
				hideDelay: 3500,
				autoHide: true,
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				loader: {
					url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_additional_links/?',
					method: 'POST',
					params: {host_id: obj.getAttribute('data-id')},
					text: langArray["Loading"] + '...',
					nocache: true
				},
				listeners: {
					beforeshow: function updateTipBody(tip) {
						tip.loader.load();
					}
				}
			});
			MemoryMgr.push(ttip);
		});

		// Add additional info tooltip
		var array = Ext.query('.host-additional-info');
		Ext.each( array, function(x,i) {

			var obj = Ext.get(array[i]);
			var ttip = new Ext.tip.ToolTip({
				target: obj.dom,
				mouseOffset: [ 0, -5],
				width: 300,
				showDelay: 1000,
				hideDelay: 3500,
				dismissDelay: 0,
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				loader: {
						url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_additional_info/?',
						method: 'POST',
						params: {host_id: obj.getAttribute('data-id')},
						text: langArray["Loading"] + '...',
						nocache: true
				},
				listeners: {
					beforeshow: function updateTipBody(tip) {
						tip.loader.load();
					}

				}
			});
			MemoryMgr.push(ttip);
		});

		// Add monitoring problem tooltip
		var array = Ext.query('.host-monitoring-problem');
		Ext.each( array, function(x,i) {
			var obj = Ext.get(array[i]);
			var ttip = new Ext.tip.ToolTip({
				target: obj.dom,
				mouseOffset: [0, -5],
				trackMouse:true,
				width: 300,
				showDelay: 1000,
				dismissDelay: 0,
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				autoLoad: {
						url: '/opmon/seagull/www/index.php/statusgrid/action/get_host_monitoring_problems/?',
						method: 'POST',
						params: {host_id: obj.getAttribute('data-id')},
						text: langArray["Loading"] + '...',
						nocache: true
				}
			});
			MemoryMgr.push(ttip);
		});

	},

	// Service grid
	normalizeServiceGrid: function() {
		StatusgridCallback.normalizeHostGrid();
		StatusgridCallback.normalizeOnlyServiceGrid();
		StatusgridEvents.restoreDisplayRows();
	},

	normalizeOnlyServiceGrid: function() {

		// Add service tooltip
		var array = Ext.query('.service-tooltip');
		Ext.each( array, function(x,i) {

			var obj = Ext.get(array[i]);
			var reg = /^(\d*)!(\d*)$/;
			var parse = reg.exec( obj.getAttribute('data-id') );
			if (!parse)
				return;
		
			var host_id = parse[1];
			var service_id = parse[2] || 0;
			
			obj.removeAllListeners();
			
			var ttip = new Ext.tip.ToolTip({
				target: obj.dom,
				trackMouse:true,
				mouseOffset: [0, 10],
				width: 400,
				showDelay: 1000,
				dismissDelay: 0,
				closeAction: 'destroy',
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				loader: {
					url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_tooltip/?',
					method: 'POST',
					params: {host_id: host_id, service_id: service_id},
					text: langArray["Loading"] + '...',
					nocache: true,
					listeners: {
						load: function() {
							dom_id = "performanceGraphic_" + host_id + '_' + service_id;

							if (Ext.get(dom_id) == null) {
								return;
							}

							var cpObj = new Object();

							cpObj.reportPeriod = 'last24hours';
							cpObj.selectedItens = [host_id + '!' + service_id];
							cpObj.reportType = '0';
							cpObj.objectType = '1';
							cpObj.timeCutId = "100";

							constructGraphic(
								cpObj,
								'cp',
								dom_id,
								undefined,
								false
							);
						}
					}
				},
				listeners: {
					beforeshow: function(tip) {
						tip.loader.load();
					}
				}
			});
			MemoryMgr.push(ttip);
		});

		// Add external links tooltip
		var array = Ext.query('.service-additional-links');
		Ext.each( array, function(x,i) {

			var obj = Ext.get(array[i]);
			var reg = /^(\d*)!(\d*)$/;
			var parse = reg.exec( obj.getAttribute('data-id') );
			if (!parse)
				return;

			var host_id = parse[1];
			var service_id = parse[2] || 0;
			
			obj.removeAllListeners();
			
			var ttip = new Ext.tip.ToolTip({
				target: obj.dom,
				mouseOffset: [0, -5],
				width: 180,
				showDelay: 1000,
				dismissDelay: 0,
				hideDelay: 3500,
				autoHide: true,
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				loader: {
					url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_additional_links/?',
					method: 'POST',
					params: {host_id: host_id, service_id: service_id},
					text: langArray["Loading"] + '...',
					nocache: true
				},
				listeners: {
					beforeshow: function updateTipBody(tip) {
						tip.loader.load();
					}
				}
			});
			MemoryMgr.push(ttip);
		});

		// Add additional info tooltip
		var array = Ext.query('.service-additional-info');
		Ext.each( array, function(x,i) {

			var obj = Ext.get(array[i]);
			var reg = /^(\d*)!(\d*)$/;
			var parse = reg.exec( obj.getAttribute('data-id') );
			if (!parse)
				return;

			var host_id = parse[1];
			var service_id = parse[2] || 0;

			obj.removeAllListeners();

			var ttip = new Ext.tip.ToolTip({
				target: obj.dom,
				mouseOffset: [ 0, -5],
				trackMouse:true,
				width: 300,
				showDelay: 1000,
				hideDelay: 3500,
				dismissDelay: 0,
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				loader: {
						url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_additional_info/?',
						method: 'POST',
						params: {host_id: host_id, service_id: service_id},
						text: langArray["Loading"] + '...',
						nocache: true
				},
				listeners: {
					beforeshow: function updateTipBody(tip) {
						tip.loader.load();
					}
				}
			});
			MemoryMgr.push(ttip);
		});

		// Add monitoring problem tooltip
		var array = Ext.query('.service-monitoring-problem');
		Ext.each( array, function(x,i) {

			var obj = Ext.get(array[i]);
			var reg = /^(\d*)!(\d*)$/;
			var parse = reg.exec( obj.getAttribute('data-id') );
			if (!parse)
				return;

			var host_id = parse[1];
			var service_id = parse[2] || 0;
			
			obj.removeAllListeners();
			
			var ttip = new Ext.tip.ToolTip({
				target: obj.dom,
				mouseOffset: [0, -5],
				trackMouse:true,
				width: 300,
				showDelay: 1000,
				dismissDelay: 0,
				bodyBorder: false,
				frame: false,
				baseCls: 'object-tooltip',
				loader: {
						url: '/opmon/seagull/www/index.php/statusgrid/action/get_service_monitoring_problems/?',
						method: 'POST',
						params: {host_id: host_id, service_id: service_id},
						text: langArray["Loading"] + '...',
						nocache: true
				},
				listeners: {
					beforeshow: function updateTipBody(tip) {
						tip.loader.load();
					}
				}
			});
			MemoryMgr.push(ttip);
		});
	},

	// Hostgroup grid
	normalizeHostgroupGrid: function() {
		StatusgridCallback.normalizeHostGrid();
		StatusgridEvents.restoreDisplayRows();
	},

	// ------------------------------
	//
	// Servicegroup grid
	//
	// ------------------------------

	normalizeServicegroupGrid: function() {
		StatusgridCallback.normalizeHostGrid();
		StatusgridCallback.normalizeOnlyServiceGrid();
		StatusgridEvents.restoreDisplayRows();
	}
}
