var CollapsedElements = [];
var doingPDF = false;

var StatusgridEvents = {

	setTitle: function() {
		var title = Ext.get('gridTitle');
		if (!title || !parent.setPageTitle)
			return;

		parent.setPageTitle(title.dom.value,0);
	},
	displayRows: function(img) {
		var arr = Ext.query("." + img.getAttribute('data-id'));
		Ext.each(arr, function(obj) {
			var row = Ext.get(obj);
			row.setVisibilityMode(Ext.Element.DISPLAY);
			row.toggle();
		});

		if (img.src.match("minus")) {
			img.src = img.src.replace("minus","plus");
			if (CollapsedElements.indexOf(img.getAttribute('data-id')) < 0) {
				CollapsedElements.push(img.getAttribute('data-id'));
				StatusgridEvents.saveDisplayRows(CollapsedElements);
			}
			return;
		}

		img.src = img.src.replace("plus","minus");
		var index = CollapsedElements.indexOf(img.getAttribute('data-id'));
		if (index >= 0)
			CollapsedElements.splice(index,1);
		
		StatusgridEvents.saveDisplayRows(CollapsedElements);
	},
	saveDisplayRows: function (collapseddata) {
		//save cookie with collapsed grid
		setCookie('collapsedElements', JSON.stringify(collapseddata), '365', '/', '', '' );
	},
	restoreDisplayRows: function() {
		//restore collapsed grid data
		var collapseddata = JSON.parse(getCookie('collapsedElements'));
		CollapsedElements = (collapseddata) ? collapseddata : [];

		Ext.each(CollapsedElements, function(id) {
			var img = Ext.query("img[data-id=" + id + "]");
			img = Ext.get(img[0]);
			
			if (img) {
				StatusgridEvents.displayRows(img.dom);
			}
		});
	},
	getGridCheckboxes: function() {
		return Ext.query('input.row-checkbox');
	},
	checkAndUncheck: function(main) {
		if (main.checked)
			StatusgridEvents.cookieAddEl(main.getAttribute('data-id'));
		else
			StatusgridEvents.cookieDelEl(main.getAttribute('data-id'));

		var boxes = [];
		boxes = this.getGridCheckboxes();
		Ext.each(boxes, function(cbox) {
			var valid_ids = /^\d+.*$/;

			if (!String(cbox.getAttribute('data-id')).match(valid_ids))
				return;

			cbox.checked = main.checked;
			StatusgridEvents.verifyCheckbox(false,cbox);
		});
	},
	getChildrenCheckboxes: function(name) {
		var checkboxes = [];
		checkboxes = Ext.query(".child-"+name);
		checkboxes = checkboxes.concat(Ext.query("input[data-id^="+name+"!]"));
		return checkboxes;
	},
	verifyCheckbox: function(event, cbox) {

		/**
		 * user has selected a host, 
		 * a service group or a host group,
		 * check/uncheck all children
		 */
		if (cbox.getAttribute('data-id').indexOf("!") < 0) {
			Ext.each(StatusgridEvents.getChildrenCheckboxes(cbox.getAttribute('data-id')), function(box) {
				box.checked = cbox.checked;
				if (cbox.checked)
					StatusgridEvents.cookieAddEl(box.getAttribute('data-id'));
				else
					StatusgridEvents.cookieDelEl(box.getAttribute('data-id'));
			});
		}

		if (cbox.checked)
			StatusgridEvents.cookieAddEl(cbox.getAttribute('data-id'));
		else
			StatusgridEvents.cookieDelEl(cbox.getAttribute('data-id'));
	},
	addService: function() {
		var props = {};
		props.action = "addService";
		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	delService: function() {
		var props = {};
		var i;
		var arr;
		var obj;
		var sel;

		sel = StatusgridEvents.getSelectedCheckboxes();
		if (sel.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props.services = [];
		for(i=0; i<sel.length; i++) {
			arr = sel[i].match(/(\d+)!(\d+)/);
			if (arr === null || arr.length != 3) {
				continue;
			}

			obj = {
				host_id: arr[1],
				service_id: arr[2]
			};
			props.services.push(obj);
		}

		if (props.services.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props.action = "deleteServices";
		props.width = 250;
		props.height = 195;
		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);

	},
	cookieAddEl: function(idx) {
		try {
			elems = Ext.decode(Ext.util.Cookies.get('previousSelectedElements'));
			if (Array.isArray(elems) === false) elems = new Array();
		} catch(e) {
			elems = new Array();
		}

		if (StatusgridEvents.findElemIndex(idx,elems) > -1)
			return;

		elems.push(idx);
		Ext.util.Cookies.set('previousSelectedElements',Ext.encode(elems));
	},
	cookieDelEl: function(idx) {
		elems = Ext.util.Cookies.get('previousSelectedElements');
		if (!elems) {
			elems = new Array();
		} else {
			elems = Ext.decode(elems);
		}

		var arr_idx = StatusgridEvents.findElemIndex(idx,elems);
		if (arr_idx < 0)
			return;

		elems.splice(arr_idx,1);
		Ext.util.Cookies.set('previousSelectedElements',Ext.encode(elems));
	},
	findElemIndex: function(elem,arr) {
		if ((arr === null) || (arr === undefined))
			return -1;
		
		for (var i=0; i<arr.length;i++) {
			if (elem == arr[i]) {
				return i;
			}
		}
		return -1;
	},
	addCheckboxListeners: function() {
		var elems = Ext.util.Cookies.get('previousSelectedElements');

		if (elems) {
			elems = Ext.decode(elems);
			for (var i=0; i<elems.length; i++) {
				var checkbox = Ext.query('input[data-id=' + elems[i] + ']');
				if (checkbox.length !== 1)
					continue;
				
				checkbox = Ext.get(checkbox[0]);
				checkbox.dom.checked = true;
				StatusgridEvents.verifyCheckbox(false,checkbox.dom);
			}
		}

		// Add new listeners
		Ext.each(this.getGridCheckboxes(), function(element) {
			var checkbox = Ext.get(element);
			checkbox.on('click',StatusgridEvents.verifyCheckbox);
		});

	},
	findCheckboxIndex: function(id) {
		var sel;
		sel = StatusgridEvents.getSelectedCheckboxes();
		for (var i=0; i<sel.length;i++) {
			if (id == sel[i])
				return i;
		}
		return -1;
	},
	noElementSelected: function() {

		var win = Ext.getCmp('alertWin');
		if (!win) {
			win = new Ext.Window({
				applyTo: 'alertWin',
				id: 'alertWin',
				contentEl: 'noElementsWin',
				layout: 'fit',
				width: 300,
				autoHeight:	true,
				buttonAlign: 'center',
				plain: false,
				modal: true,
				closable: false,
				closeAction: 'hide',
				draggable: false,
				shadow: false,
				baseCls: 'ext-window',
				bodyBorder: false,
				hideBorders: true,
				border: true,
				resizable: false
			});
		}
		win.center();
		win.show();
	},
	validateBasicSearch: function(form) {
		var obj = form.elements[0];
		var btn = parent.Ext.get("cancelSearch");

		if (obj.value.length) {
			obj.className += " filter-active";

			btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");
			btn.dom.style.cursor = "pointer";
		} else {
			if (obj.className.match(" filter-active"))
				obj.className = "basic-search-input";

			btn.dom.style.cursor = "default";
		}
	  
		StatusgridEvents.hideAdvancedSearch();
	},
	cancelSearch: function() {
		var form = parent.Ext.get('searchForm').dom;
		form.reset();
		StatusgridEvents.hideAdvancedSearch();
		parent.mFrame.StatusgridEvents.validateBasicSearch(form);
		form.submit();
	},
	showAdvancedSearch: function() {

		var obj = false;
		var link = false;
		if (parent) {
			obj = parent.mFrame.Ext.get('gridAdvancedSearch');
			var arr = parent.Ext.query('.basic-search-advanced');
			link = Ext.get(arr[0]);
			delete(arr);
		} else {
			obj = mFrame.Ext.get('gridAdvancedSearch');
			var arr = Ext.query('.basic-search-advanced');
			link = Ext.get(arr[0]);
			delete(arr);
		}

		if (obj.dom.style.display === 'block') {
			link.dom.innerHTML = langArray["Advanced options"];
			obj.dom.style.display = 'none';
		} else {
			link.dom.innerHTML = langArray["Hide options"];
			obj.dom.style.display = 'block';
		}
		if (obj) {
		    obj.center();
		}

	},
	hideAdvancedSearch: function() {

		var obj = false;
		var link = false;

		if (parent) {
			obj = parent.mFrame.Ext.get('gridAdvancedSearch');
			var arr = parent.Ext.query('.basic-search-advanced');
			link = Ext.get(arr[0]);
		} else {
			obj = mFrame.Ext.get('gridAdvancedSearch');
			var arr = Ext.query('.basic-search-advanced');
			link = Ext.get(arr[0]);
		}

		link.dom.innerHTML = langArray["Advanced options"];
		obj.dom.style.display = 'none';

	},
	validateAdvancedSearch: function(form) {
		var search = false;
		var btn = false;

		if (parent) {
			var arr = parent.Ext.query('.basic-search-input');
		search = arr[0];
			delete(arr);

			btn = parent.Ext.get("cancelSearch");
		} else {
			var arr = Ext.query('.basic-search-input');
			search = arr[0];
			delete(arr);

			btn = Ext.get("cancelSearch");
		}

		search.value = "(" + langArray["Filter activated"] + ")";
		if (!search.className.match(" filter-active")) {
			search.className += " filter-active";
		}

		btn.dom.src = btn.dom.src.replace("ico-cancela-busca-disabled.","ico-cancela-busca.");

		btn.dom.style.cursor = "pointer";

		StatusgridEvents.hideAdvancedSearch();
	},
	renderComboboxes: function() {
		var form = Ext.get('gridAdvancedSearch');
                
		if (form && form.dom.style.display !== 'none') {
			return;
		}

		// Clean previous allocated memory
		Ext.each(FilterMemoryMgr, function(memObj,memIndex) {
			if (memObj.destroy) {
                //memObj.destroy();
				delete(memObj);
			} else if (memObj.removeAllListeners) {
				memObj.removeAllListeners();
			}
		});

		FilterMemoryMgr = [];

		var objs = Ext.query('.combo-autocomplete');

		Ext.each( objs, function(x,index) {
			var obj = Ext.get(x);
			var ds = new Ext.data.Store({
				proxy: {
					url: '/opmon/seagull/www/index.php/statusgrid/action/comboContent/filter/' + obj.id,
					type: 'ajax',
					noCache: false,
					actionMethods: {
						read: 'POST'
					},
					reader: {
						root: 'data',
						totalProperty: 'total',
						id: 'id'
					}
				},
			fields: [
					{name: 'id', mapping: 'id'},
					{name: 'display_name', mapping: 'display_name'}
				]
			});

			FilterMemoryMgr.push(ds);

			var content = obj.dom.innerHTML;
			obj.dom.innerHTML = "";

			var combo = new Ext.form.ComboBox({
					store: ds,
					displayField: 'display_name',
					loadingText: '',
					renderTo: x,
					width: 198,
					shadow: 'sides',
					defaultListConfig : {
						loadingHeight: 70,
						border: 1,
						style: {
							borderStyle: 'solid'
						},
						shadow: 'sides',
						cls: 'copy-shadow'
					},
					tpl: new Ext.XTemplate('<ul class="x-list-plain">\n\
												<tpl for=".">\n\
													<li role="option" unselectable="on" class="x-boundlist-item combobox-list">{display_name}</li>\n\
												</tpl>\n\
											</ul>'),
					hideTrigger: true,
					name: 'filter[' + obj.id + ']',
					minChars: 1,
					value: content,
					cls: 'advanced-form-element combobox-list no-input-border',
					id: 'combo_' + obj.id
			});
			FilterMemoryMgr.push(combo);
		});

	},
	renderDatetimePicker: function() {

		Date.monthNames = [
			langArray["Jan"],
			langArray["Feb"],
			langArray["Mar"],
			langArray["Apr"],
			langArray["May"],
			langArray["Jun"],
			langArray["Jul"],
			langArray["Aug"],
			langArray["Sep"],
			langArray["Oct"],
			langArray["Nov"],
			langArray["Dec"]
		];

		Date.dayNames = [
			langArray["Sunday"],
			langArray["Monday"],
			langArray["Tuesday"],
			langArray["Wednesday"],
			langArray["Thursday"],
			langArray["Friday"],
			langArray["Saturday"]
		];

		if(Ext.DatePicker){
			Ext.apply(Ext.DatePicker.prototype, {
			  todayText         : langArray["Today"],
			  monthNames        : Date.monthNames,
			  dayNames          : Date.dayNames,
			  cancelText	: langArray["Cancel"]
			});
		}

		var form = Ext.get('gridAdvancedSearch');
		if (form) {
			if (form.dom.style.display != 'none')
			return;
		}

		var objs = Ext.query('.datetime-picker');
		Ext.each( objs, function(x,index) {
			var obj = Ext.get(x);

			var content = obj.dom.innerHTML;
			obj.dom.innerHTML = "";

			var has_cache = (content.split(" ").length == 2);

			if (obj.id == 'log_day_end') {
				var date = (has_cache) ? content.split(" ")[0] : new Date();
				var time = (has_cache) ? content.split(" ")[1] : '23:59:59';
			}

			if (obj.id == 'log_day') {
				var date = (has_cache) ? content.split(" ")[0] : new Date();
				var time = (has_cache) ? content.split(" ")[1] : '00:00:00';
			}

			var field = new Ext.form.FormPanel({
				renderTo:       x
				,width:         200
				,layout:        {
					 type:		'hbox'
					,pack:		'start'
					,align:		'top'
				}
				,bodyPadding:		0
				,items: [{
					xtype:          'datefield'
					,margin:        '0 2 0 2'
					,minWidth:		100
					,height:		22
					,allowBlank:    false
					,editable:      false
					,name:          'filter[date_'+obj.id+']'
					,cls:           'no-input-border'
					,format:        'Y-m-d'
					,value:         date
					,flex:			1
				}, {
					xtype:          'timefield'
					,width:         100
					,height:		22
					,allowBlank:    false
					,editable:      true
					,name:          'filter[time_'+obj.id+']'
					,id:            obj.id + '_time'
					,cls:           'no-input-border'
					,value:			time
					,minValue:      '00:00:00'
					,maxValue:      '23:59:59'
					,increment:     15
					,format:        'H:i:s'
					,flex:			1
				}]
			});

			if ((!has_cache) && (obj.id == 'log_day_end')) {
				field.down('#'+obj.id+'_time').setValue('23:59:59');
			}

			FilterMemoryMgr.push(field);
		});
	},
	renderDatePicker: function() {

		Date.monthNames = [
			langArray["Jan"],
			langArray["Feb"],
			langArray["Mar"],
			langArray["Apr"],
			langArray["May"],
			langArray["Jun"],
			langArray["Jul"],
			langArray["Aug"],
			langArray["Sep"],
			langArray["Oct"],
			langArray["Nov"],
			langArray["Dec"]
		];

		Date.dayNames = [
			langArray["Sunday"],
			langArray["Monday"],
			langArray["Tuesday"],
			langArray["Wednesday"],
			langArray["Thursday"],
			langArray["Friday"],
			langArray["Saturday"]
		];

		if(Ext.DatePicker){
			Ext.apply(Ext.DatePicker.prototype, {
			  todayText         : langArray["Today"],
			  monthNames        : Date.monthNames,
			  dayNames          : Date.dayNames,
			  cancelText	: langArray["Cancel"]
			});
		}

		var form = Ext.get('gridAdvancedSearch');
		if (form) {
			if (form.dom.style.display != 'none')
			return;
		}

		var objs = Ext.query('.date-picker');
			Ext.each( objs, function(x,index) {
				var obj = Ext.get(x);
				var content = /*new Date();*/obj.dom.innerHTML;
				obj.dom.innerHTML = "";
				var field = new Ext.form.DateField({
					editable:	false,
					format:		'Y-m-d',
					renderTo:	x,
					width:		198,
					height:		22,
					name:		'filter[' + obj.id + ']',
					value:		content,
					cls:		'no-input-border',
					id:			'combo_' + obj.id,
					listeners: {
						focus: function() {
							if (obj.id === objs[0].id + "_end") {
								var first_datepicker = Ext.getCmp('combo_' + objs[0].id).getValue();
								Ext.getCmp('combo_' + obj.id).setMinValue(first_datepicker);
							}
						}
					}
				});
				FilterMemoryMgr.push(field);
			});
	},
	adjustGridLayout: function() {

		var header = Ext.get('gridHeaderBox');
		if (!header)
			return;
		var tbar = Ext.get('gridToolbar');
		if (!tbar)
			return;

		tbar.setWidth( header.getWidth() );

		var body = Ext.getBody();
		if (!body)
			return;
		var tableBody = Ext.get('gridTableBody');
		if (!tableBody)
			return;
		var newSize = body.getHeight()-130;

		if (tableBody.getHeight()>=newSize) {
			tableBody.setHeight(newSize);
			return;
		}

		if (tableBody.dom.style.removeAttribute)
			tableBody.dom.style.removeAttribute("height");
		else
			tableBody.dom.style.removeProperty("height");

	},
	editServices: function() {
		var props = {};
		var selectedServices;

		selectedServices = Statusgrid.getSelectedServiceDescriptionsOnServiceStatusGrid();
		if (selectedServices.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props.action = "editServices";
		props.services = selectedServices;
		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	editHosts: function() {
		var hosts;
		var props = {};

		props.hosts = Statusgrid.getSelectedHostNamesOnHostStatusGrid();
		if (props.hosts.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	addHost: function() {
		var hosts;
		var props = {
			action: 'addHost'	
		};

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	cloneService: function() {
		var props = {};
		var selectedServices;

		selectedServices = Statusgrid.getSelectedServiceDescriptionsOnServiceStatusGrid();
		if (selectedServices.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		props = {
			action: 'cloneService',	
			services: selectedServices,
			width: 400,
			height: 200
		};

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	cloneHost: function() {

		hosts = Statusgrid.getSelectedHostNamesOnHostStatusGrid();
		if (hosts.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		var hosts;
		var props = {
			action: 'cloneHost',	
			hostName: hosts[0],
			width: 400,
			height: 190 
		};

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);
	},
	delHost: function() {

		var sel;

		sel = StatusgridEvents.getSelectedCheckboxes();
		if (sel.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		var props = {
			action: 'deleteHosts',	
			hosts: sel,
			width: 250,
			height: 170,
			title: langArray['Remove']
		};

		props.callback = "StatusgridEvents.closeConfigurationWindow";
		Statusgrid.openConfigurationWindow(props);

	},
	closeConfigurationWindow: function(success) {
		if (success)
			parent.showSystemAlert(ALERT_OK,langArray['Informations'],langArray['Command submitted successfully']);

		var w = Ext.getCmp("global_config_window");
		if (w)
			w.destroy();

		Ext.get("gridRefresh").dom.onclick({});
	},
	genPDFFromGrid: function () {

		var action = Ext.get('gridName').dom.value;
		var params = Ext.get('gridParams').dom.value.split("&");
		var tmp    = Ext.get('gridFilter').dom.value;
		var title  = Ext.get('gridTitle').dom.value;;
		var filter = {};
		var URL;

		filter.collapsed_hosts = [];
		Ext.each(CollapsedElements, function(id) {
			filter.collapsed_hosts.push(
				id.replace('grid-row-id-',"")
			);
		});

		if (action == 'notifications') {
			URL = '/opmon/seagull/www/index.php/opexporter/action/genpdffromnotificationsgrid/';
		} else {
			URL = '/opmon/seagull/www/index.php/opexporter/action/genpdffromgrid/';
		}


		var icon = Ext.get('genpdf_icon');
		if (icon) {
			icon.dom.src = icon.dom.src.replace("icon-pdf", "loading");
			doingPDF = true;
		}


		if (tmp !== undefined) {
			filter.filter = Ext.JSON.decode(tmp, true);
			filter.params = {};
			var obj;
			Ext.each(params, function (el){
				el = el.split('=');
				if (el[0] !== "limit") {
					obj = (obj === undefined) ? '"' + el[0] + '":"' + el[1] + '"' : obj + ',"' + el[0] + '":"' + el[1] + '"';
				} else {
					obj = (obj === undefined) ? '"' + el[0] + '":"0"' : obj + ',"' + el[0] + '":"0"';
				}
			});

			filter.params	= Ext.JSON.decode("{" + obj + "}", true);
		} else {
			filter.filter = {};
		}

		filter.type     = action;
		if (title !== undefined) {
			filter.title    = encodeURI(title);
		}

		if (action == 'notifications') {
			filter.form_to  = 40;
		} else if (action == "services") {
			filter.form_to  = 50;
		} else if (action == "servicegroups") {
			filter.form_to  = 51;
		}

		filter = Ext.JSON.encode(filter);
		URL += '&jsonData=' + filter;

		Ext.Ajax.useDefaultXhrHeader = false;
		Ext.Ajax.request({
			url: URL,
			method: 'GET',
			timeout: 180000,
			success: function (result, request) {
				var obj = Ext.JSON.decode(result.responseText);
				location = obj.cacheurl;

				icon = Ext.get('genpdf_icon');
				if (icon) {
					icon.dom.src = icon.dom.src.replace("loading", "icon-pdf");
					doingPDF = false;
				}
			},
			failure: function (request, result) {
				icon = Ext.get('genpdf_icon');
				if (icon) {
					icon.dom.src = icon.dom.src.replace("loading", "icon-pdf");
					doingPDF = false;
				}
			}
		});
		Ext.Ajax.useDefaultXhrHeader = true;
	},
	genReportFromGrid: function(reportType, objectType) {

		var URL;
		var CPREPORT = 1;

		if (reportType != CPREPORT) {
			URL = '/opmon/seagull/www/index.php/opreports/action/index/';
		} else {
			URL = '/opmon/seagull/modules/opreports/ng/app.php';
		}

		// Set reportType
		URL += '?formTo=' + reportType;

		// Set manualMode
		var manualMode = new Object();
		manualMode.reportType = '0';
		manualMode.timeCutName = '24x7';
		manualMode.reportPeriod	= 'last24hours';
		manualMode.objectType = objectType;
		manualMode.timeCutId = Ext.get('gridReportPeriod').dom.value;

		if (reportType === AVAILREPORT) {
			manualMode.reportType = AVAILDETAILED;
		}

		manualMode.selectedItensDescription = [];
		manualMode.selectedItens = StatusgridEvents.getSelectedCheckboxes();

		manualMode.selectedItens.forEach(function(item){
			manualMode.selectedItensDescription.push({value: item})
		});

		if (manualMode.selectedItens.length === 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		var param = Ext.JSON.encode(manualMode);
		param = param.replace(/\"/g, "'");
		URL += '&manualMode=' + param;

		var frame = parent.Ext.get('mainFrame');
		frame.dom.src = URL;

	},
	getSelectedCheckboxes: function() {
		var selectedItems = [];
		var validIds = /^\d+/;
		Ext.each(Ext.query("input[class^=row-checkbox]"), function(box) {
			if (!box.checked || !validIds.test(box.getAttribute('data-id')))
				return;
			selectedItems.push(box.getAttribute('data-id'));
		});
		return selectedItems;
	},
	runExternalCommand: function(objectType) {
		var objects = [];
		var win;

		objects = StatusgridEvents.getSelectedCheckboxes();
		if (objects.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}
		
		win = Ext.create('Ext.window.Window',{
			id:             'extCmdWin',
			layout:         'fit',
			width:          260,
			autoHeight:     true,
			y:              100,
			buttonAlign:    'center',
			plain:          false,
			modal:          true,
			closable:       false,
			closeAction:    'destroy',
			draggable:      false,
			shadow:         false,
			bodyCls:		'ext-window',
			bodyBorder:     false,
			hideBorders:    false,
			resizable:      false,
			loader: {
				url: '/opmon/seagull/www/index.php/statusgrid/action/external_command_list/?',
				method: 'POST',
				params: {
					elements: Ext.JSON.encode(objects), 
					objectType: objectType
				},
				text: langArray['Loading'] + '...',
				nocache: true,
				autoLoad: true,
				success: function(){
					win.center();
				}
			},
			listeners: {
				hide: function() {
					Ext.get('cmdWin').dom.innerHTML = "";
				}
			}
		}).show();
	},
	genRealtimeGraph: function() {

		var objects;
		objects = StatusgridEvents.getSelectedCheckboxes();

		if (objects.length == 0) {
			StatusgridEvents.noElementSelected();
			return;
		}

		Ext.each(objects,function(obj,index) {
			if (obj.indexOf("!") < 0)
				return;

			var objIds = [];
			objIds = obj.split("!");
			var url = '/opmon/seagull/www/index.php/statusgrid/action/realtimegraph';
			url += '/host_id/' + objIds[0];
			url += '/service_id/' + objIds[1];
			var win = window.open(url,'','height=340,width=1024,scrollbars=no,menubar=no,resizable=yes,toolbar=no,location=no,status=no');
		});

	},
	addFavoriteLink: function() {
		if (parent)
			parent.addFavoriteLink();
	},
	addShortcutLink: function() {
		if (parent)
			parent.addShortcutLink();
	}

}
